<?php
/**
 * Affiliate Software Omnistar Admin Module
 *
 * Contains all the click tracker functions for the administration module.
 *
 * @author Omnistar Software <sales@osiaffiliate.com>
 * @package Affiliate Software Omnistar
 * @version 1.0
 * @filesource
 * @copyright 2011 Omnistar Software.
 */

include 'template.inc.php';

function wpct_validate_mod_link($data){

	$errors = array();
	if(!isset($data['link_name']) || $data['link_name'] == ''){
		$errors['link_name'] = TRUE;
	}

	if(!isset($data['link_destination']) || $data['link_destination'] == ''){
		$errors['link_destination'] = TRUE;
	}

	return $errors;
}

function wpct_mod_link_form($link_id = FALSE, $req = 'add'){
	global $wpdb;
	
	$page = $_REQUEST['page'];
	$errors = FALSE;
	if($link_id){
		$link_data = wpct_get_link_data(" WHERE link_id = '$link_id'");
		$submit_value = __('Edit Link', 'wp-click-track');
		$def_name = (isset($_POST['link_name']) ? $_POST['link_name'] : $link_data['0']->link_title);
		$def_desc = (isset($_POST['description']) ? $_POST['description'] : $link_data['0']->link_desc);
		$def_dest = (isset($_POST['link_destination']) ? $_POST['link_destination'] : $link_data['0']->link_destination);

	} else {
		$submit_value = __('Add Link', 'wp-click-track');
		$def_name = (isset($_POST['link_name']) ? $_POST['link_name'] : FALSE);
		$def_desc = (isset($_POST['description']) ? $_POST['description'] : FALSE);
		$def_dest = (isset($_POST['link_destination']) ? $_POST['link_destination'] : FALSE);
	}

	if(isset($_POST['link_name'])){
		$errors = wpct_validate_mod_link($_POST);
		if(count($errors) == '0'){
			$errors = FALSE;
		} else {
			echo '<div class="error">'.__('Please fill out all required fields.', 'wp-click-track').'</div>';
		}
	}

?>

	<form name="add_click_track" id="add_click_track" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?page=wp-click-track/manage.php">
	<?php
		if($link_id){
			echo '<input type="hidden" name="link" value="'.$link_id.'">';
		}
	?>
	<input type="hidden" name="req" value="<?php echo $req; ?>" />
	<input type="hidden" name="page" value="<?php echo $page; ?>" />
	<input type="hidden" name="mod_wpct_link" value="yes" />
	<div>

	<?php
	$link_error = '';
	if(isset($errors['link_name'])){
		$link_error = '<div class="error">'.__('Required', 'wp-click-track').'</div>';
	}

	$cols = array('<label for="link_name">'.__('Link Name (required)', 'wp-click-track').'</label>');
	$rows = array(
				array(
				'<div class="form-field">'.$link_error.'<input name="link_name" id="link_name" type="text" value="'.$def_name.'" size="40"/></div>'.__('Example: Affiliate Software Omnistar', 'wp-click-track')
				)
			);
	echo wpct_admin_table($cols, $rows, $msg = FALSE, $tfoot = FALSE, $add_break = TRUE);

	if(isset($errors['link_destination'])){
		echo '<div class="error">'.__('Required').'</div>';
	}

	$cols = array('<label for="link_destination">'.__('Application URL (required)', 'wp-click-track').'</label>');
	$rows = array(
				array(
				'<div class="form-field"><input name="link_destination" id="link_destination" type="text" value="'.$def_dest.'" size="40" /></div>'.__('Example:', 'wp-click-track').'<code>http://www.osiaffiliate.com/</code> &#8212; '.__('don&#8217;t forget the', 'wp-click-track').'<code>http://</code>'
				)
			);
	echo wpct_admin_table($cols, $rows, $msg = FALSE, $tfoot = FALSE, $add_break = TRUE);

	$cols = array('<label for="description">'.__('Description (optional)', 'wp-click-track').'</label>');
	$rows = array(
				array(
				'<div class="form-field"><textarea name="description" id="description" rows="5" cols="40">'.$def_desc.'</textarea></div>'.__('This will be shown when someone hovers over the link.', 'wp-click-track')
				)
			);
	echo wpct_admin_table($cols, $rows, $msg = FALSE, $tfoot = FALSE, $add_break = TRUE);
	?>

	<p class="submit"><input type="submit" class="button" name="submit" value="<?php echo $submit_value; ?>" /></p>
	</div>
	</form>
<?php
}

/**
 * Lists all the links for a situation
 *
 * @return  void
 */
function wpct_list_links($result, $total, $date_ranges = FALSE, $display_message = TRUE){

	$cols = array(__('Title', 'wp-click-track'),__('Application URL', 'wp-click-track')/*,__('Total Clicks', 'wp-click-track'),__('Unique Clicks', 'wp-click-track')*/);
	$rows = array();
	if($date_ranges){
		$cols[] = __('First Click', 'wp-click-track');
		$cols[] = __('Last Click', 'wp-click-track');
	}

	$page_vars = wpct_get_page_values();

	for($i=0;$i<$total;$i++){
		$link_destination_title = (strlen($result[$i]->link_destination) >= 50 ? substr($result[$i]->link_destination,0,50).'...' : $result[$i]->link_destination);
		$rows[$i] = array('<a href="'.$_SERVER['PHP_SELF'].'?page='.$page_vars['manage'].'&link='.$result[$i]->link_id.'&req=edit">'.$result[$i]->link_title.'</a>',
						'<a href="'.$result[$i]->link_destination.'" target="_blank" title="'.$result[$i]->link_destination.'">'.$link_destination_title.'</a></td>',
						//number_format_i18n($result[$i]->link_total_clicks),
						//number_format_i18n($result[$i]->link_unique_clicks)
					);

		if($date_ranges){
			$rows[$i][] = $date_ranges['first_click'];
			$rows[$i][] = $date_ranges['last_click'];
		}
	}

	echo wpct_admin_table($cols,$rows,__('NOTE: Only links that have been clicked are above.', 'wp-click-track'));
}

function wpct_admin_list_links($req, $page, $paged, $ref_paged){
	global $wpdb;

	//setup search
	$BuildWhere = '';
	$_search = FALSE;
	$page_query = 'paged';
	if(isset($_REQUEST['s']) && trim($_REQUEST['s']) != ''){
		$_search = $_REQUEST['s'];
		$page_query = 's='.$_search.'&'.$page_query;

		//first check if the table is setup for fulltext searching
		$sql = " SHOW INDEXES FROM ".$wpdb->prefix."omnistar_software_links";
		$result = $wpdb->get_results($sql);
		$count = count($result);
		$full_text = FALSE;
		for($i=0;$i<$count;$i++){
			if(strtoupper($result[$i]->Index_type) == 'FULLTEXT' && $result[$i]->Key_name == 'search_index'){
				$full_text = TRUE;
				break;
			}
		}

		if($full_text == TRUE){
			$BuildWhere = " WHERE MATCH(link_title,link_desc,link_destination) AGAINST('$_search' IN BOOLEAN MODE) ";
		} else {
			$BuildWhere = " WHERE link_title LIKE '%$_search%' ";
		}
	}

	$total_links = wpct_get_link_count($BuildWhere);

	$plugin_options = get_option('Affiliate_Software_Omnistar');
	$link_page_total = $plugin_options['link_list_count'];

	$limitvalue = $paged * $link_page_total - ($link_page_total);

	$numofpages = ceil($total_links / $link_page_total);

	$result = wpct_get_link_data(" $BuildWhere ORDER BY link_total_clicks DESC LIMIT $limitvalue,$link_page_total");
	$select_total = count($result);

	echo '<table width="100%"><tr><td>';
	if($_search) {
		echo '<h3>'.__('Search Results For', 'wp-click-track').': <em>'.$_search.'</em></h3>';
	} else {
		echo '<h3>'.__('Omnistar Affiliate Software Info', 'wp-click-track').'</h3>';
	}
	
	echo '</td><td align="right">';

	echo wpct_pagination($numofpages, $paged, $link_page_total, $total_links, '', $page_query);
	echo '</td></tr></table>';

	wpct_list_links($result, $select_total,FALSE,FALSE);

	echo wpct_pagination($numofpages, $paged, $link_page_total, $total_links, '', $page_query);

}

/**
 * Displays administration quick view 
 *
 * @return  void
 */
function wpct_link_data(){
	global $wpdb;

	$post_id = (isset($_REQUEST['post']) ? $_REQUEST['post'] : FALSE);

	if(!$post_id){
		return FALSE;
	}

	$sql = "SELECT post_content,post_excerpt FROM ".$wpdb->prefix."posts WHERE ID = '".$wpdb->escape($post_id)."'";
	$result = $wpdb->get_results($sql);
	$select_total = count($result);
	?>

<div id='normal-sortables' class='meta-box-sortables '>
<div id="postexcerpt" class="postbox " >
<div class="handlediv" title="Click to toggle"><br /></div><h3 class='hndle'><span><?php _e('Click Tracker', 'wp-click-track'); ?></span></h3>
<div class="inside">

<?php
	$post_links = wpct_extract_urls($result['0']->post_content);
	$_check_urls = array();
	$total = count($post_links);
	for($i=0;$i<$total;$i++){
		$_check_urls[] = $wpdb->escape($post_links[$i]['href']);
	}
	$_check_urls = "'".implode("','",$_check_urls)."'";
	$sql = "SELECT link_title,link_destination,link_total_clicks,link_unique_clicks FROM ".$wpdb->prefix."omnistar_software_links WHERE link_destination IN($_check_urls)";
	$result = $wpdb->get_results($sql);

	$select_total = count($result);
	if($select_total >= '1'){

		wpct_list_links($result, $select_total, FALSE, TRUE);

	} else {

		echo __('No Links Found', 'wp-click-track');
		
	}
?>
</div>
</div>

	<?php
}